/*
 *         
 * SmoothAlgorithms.mqh version >= 3.01!!!
 *   (): MetaTrader\\MQL5\Include
 */
//+------------------------------------------------------------------+
//|                                                        AT^CF.mq5 |
//|                               Copyright  2011, Nikolay Kositsin |
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Nikolay Kositsin"
#property link "farria@mail.redcom.ru"
//----   
#property version   "1.00"
//----     
#property indicator_separate_window 
//----       4 
#property indicator_buffers 4
//----   4  
#property indicator_plots   4
//----     
#property indicator_type1   DRAW_LINE
#property indicator_type2   DRAW_LINE
#property indicator_type3   DRAW_LINE
#property indicator_type4   DRAW_LINE
//----      
#property indicator_color1  Blue
#property indicator_color2  Red
#property indicator_color3  Magenta
#property indicator_color4  Lime
//----   -  
#property indicator_style1  STYLE_SOLID
#property indicator_style2  STYLE_SOLID
#property indicator_style3  STYLE_SOLID
#property indicator_style4  STYLE_SOLID
//----     1
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  1
#property indicator_width4  1
//----   
#property indicator_label1  "FATL"
#property indicator_label2  "SATL"
#property indicator_label3  "RFTL"
#property indicator_label4  "RSTL"
//+-----------------------------------+
//|         |
//+-----------------------------------+
enum Applied_price_ // 
  {
   PRICE_CLOSE_ = 1,     //PRICE_CLOSE
   PRICE_OPEN_,          //PRICE_OPEN
   PRICE_HIGH_,          //PRICE_HIGH
   PRICE_LOW_,           //PRICE_LOW
   PRICE_MEDIAN_,        //PRICE_MEDIAN
   PRICE_TYPICAL_,       //PRICE_TYPICAL
   PRICE_WEIGHTED_,      //PRICE_WEIGHTED
   PRICE_SIMPL_,         //PRICE_SIMPL_
   PRICE_QUARTER_,       //PRICE_QUARTER_
   PRICE_TRENDFOLLOW0_, //PRICE_TRENDFOLLOW0_
   PRICE_TRENDFOLLOW1_  //PRICE_TRENDFOLLOW1_
  };

input Applied_price_ IPC=PRICE_CLOSE_;// 
/* ,      ( 1-CLOSE, 2-OPEN, 3-HIGH, 4-LOW, 
  5-MEDIAN, 6-TYPICAL, 7-WEIGHTED, 8-SIMPL, 9-QUARTER, 10-TRENDFOLLOW, 11-0.5 * TRENDFOLLOW.) */

input int FATLShift=0; //      
input int SATLShift=0; //      
input int RFTLShift=0; //      
input int RSTLShift=0; //      
//+-----------------------------------+

//----   ,    
//      
double FATLBuffer[],SATLBuffer[],RFTLBuffer[],RSTLBuffer[];

int start;
//+------------------------------------------------------------------+
//   iPriceSeries()                                   |
//   CFATL, CSATL, RFTL  CRSTL                       |
//+------------------------------------------------------------------+ 
#include <SmoothAlgorithms.mqh>  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+ 
void OnInit()
  {
//----  
   start=99;
//----      
   SetIndexBuffer(0,FATLBuffer,INDICATOR_DATA);
   SetIndexBuffer(1,SATLBuffer,INDICATOR_DATA);
   SetIndexBuffer(2,RFTLBuffer,INDICATOR_DATA);
   SetIndexBuffer(3,RSTLBuffer,INDICATOR_DATA);
//----     
   PlotIndexSetInteger(0,PLOT_SHIFT,FATLShift);
   PlotIndexSetInteger(1,PLOT_SHIFT,SATLShift);
   PlotIndexSetInteger(2,PLOT_SHIFT,RFTLShift);
   PlotIndexSetInteger(3,PLOT_SHIFT,RSTLShift);
//----      DataWindow
   PlotIndexSetString(0,PLOT_LABEL,"FATL");
   PlotIndexSetString(1,PLOT_LABEL,"SATL");
   PlotIndexSetString(2,PLOT_LABEL,"RFTL");
   PlotIndexSetString(3,PLOT_LABEL,"RSTL");
//----           
   IndicatorSetString(INDICATOR_SHORTNAME,"AT^CF");
//----     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//----      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(rates_total<start) return(0);

//----    
   int first,bar;
   double price;

//----    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
      first=0; //      
   else first=prev_calculated-1; //      

//----    CFATL, CSATL CRFTL  CRSTL   SmoothAlgorithms.mqh
   static CFATL FATL;
   static CSATL SATL;
   static CRFTL RFTL;
   static CRSTL RSTL;

//----    
   for(bar=first; bar<rates_total; bar++)
     {
      //----    price
      price=PriceSeries(IPC,bar,open,low,high,close);

      //----        
      FATLBuffer[bar]=FATL.FATLSeries(0,prev_calculated,rates_total,price,bar,false);
      SATLBuffer[bar]=SATL.SATLSeries(0,prev_calculated,rates_total,price,bar,false);
      RFTLBuffer[bar]=RFTL.RFTLSeries(0,prev_calculated,rates_total,price,bar,false);
      RSTLBuffer[bar]=RSTL.RSTLSeries(0,prev_calculated,rates_total,price,bar,false);
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
